.po 1i
.nr PO 1i
.if n .ds lq ""
.if n .ds rq ""
.if t .ds lq ``
.if t .ds rq ''
.DA "1 June, 1992"
.TL
Installing the DECWRL Modula-2 Compiler
.br
\*(DY
.NH 1
OVERVIEW
.PP
The DECWRL Modula-2 compiler for the VAX consists of three compilation phases,
an intermodule checker, and a command to invoke the various phases.  The first
phase compiles a single Modula-2 module into P-code, a machine-independent
intermediate language.  The second phase translates P-code into VAX assembly
language.  The third phase is the Unix assembler, which translates the assembly
code into an object file.
.PP
On DECStations, the first phase generates MIPS Ucode, which is then handed off
to the MIPS transation tools for optimization and code generation.
.PP
Before linking a collection of object modules, you can optionally invoke the
intermodule checker to detect any inconsistencies between modules.  You can
instruct the intermodule checker to automatically recompile any modules that
are out of date.  The linker then combines the object modules into an
executable file.
.FS
DEC, VAX, and DECStation are trademarks of Digital Equipment Corporation.
.br
Unix is a trademark of Bell Laboratories.
.br
MIPS is a trademark of MIPS, Inc.
.FE
.PP
The DECWRL Modula-2 compiler is usually distributed via anonymous ftp from
gatekeeper.pa.dec.com as the file /pub/DEC/Modula-2/m2.tar.Z.  The compiler is
also available on a 9-track, 1600 bpi tape, or a TK50 tape, both readable by
the Unix
.I tar
command.  For the purposes of this document, Unix will mean 4.3 BSD or some
recent version of Ultrix.  It may or may not run on your version of Unix.  The
main things that the compiler depends on are: itself, to compile most of the
sources; the YACC parser generator, which is used to generate parse tables for
the compiler; and the C compiler, which is used to compile some of the library
routines and the mod command.  The runtime library calls some C routines, but
they are standard across most implementations.
.PP
NOTE ABOUT LICENSES: The distribution contains no software proprietary to Bell
Laboratories or the Regents of the University of California.  The compiler was
written from scratch and is not derived from Wirth's Lilith compiler.  Software
and documentation is copyright 1984-1992 by Digital Equipment Corporation,
Maynard, Massachusetts, and is made available subject to a license agreement.
.NH 1
INSTALLING THE COMPILER
.PP
The compiler is organized mainly as the source directory m2-src, which contains
no objects, and the two object directories m2-vax and m2-mips, which contain no
sources.  Each of these three directories contains several subdirectories.  The
object directories m2-vax and m2-mips use symbolic links to point to the
sources in m2, and also contain Makefiles and object files specific to the VAX
and MIPS.
.PP
Since all directory paths used to create the compiler are self-relative, you
can create the top-level directories at any convenient place in your source
hierarchy.  Sources and object files require about 40 megabytes.  Once you've
created a directory for the distribution, cd there, then copy and unpack the
tape by typing
.br
    
.br
.I "tar xf /dev/rmt0l"
.br
.I "uncompress m2.tar.Z"
.br
.I "tar xf m2.tar"
.PP
Each subdirectory contains one or more components.  The top-level Makefiles in
m2-vax and m2-mips can be used to clean, make, or install all components at one
time: type 
.I "make clean, make,"
or
.I "make install".
You can also install
the compiler without all dependencies being satisfied by typing 
.I "make quickinstall";
this is useful for installing the distributed compiler into the default
directories described below, without actually recompiling all the source files.
.PP
Never edit any Makefiles.  All Makefiles are derived from the corresponding
Metafile (and sometimes a local Metafile.defines) in each directory.  The
top-level Metafile.defines is included by all Metafiles in all directories.
Whenever you change anything in this file, you should then incorporate these
changes into all derived Makefiles by typing 
.I "make Makefiles"
in the directories m2-vax and m2-mips.
.PP
The top-level Metafile.defines defines serveral tool names (MKDIR, CP, RM,
RDIST), directory names (DESTDIR, LIBDIR, PASSESDIR, DEFSDIR, MANDIR, BINDIR,
TESTLIBDIR), and binary executable names (MODBINNAME, PCBINNAME, P2M2BINNAME,
MODPROFBINNAME, and PREPBINNAME).  You may want to change some or all of these
names to match available tools or local naming conventions.
.PP
MKDIR is used to create directories that might not already exist.  If you don't
a version of mkdir that accepts the 
.I -p
option, you might have to create some directories by hand before managing to
install the compiler and associated files.
.PP
CP is used to install some files.  If you don't have a version of cp that
accepts the
.I -p
option, you may get new dates on some of the files each time you do the install.
.PP
RM removes files (if possible) without generating boring error messages.
.PP
RDIST (and the corresponding LOCALHOST) is the rdist program, which can be used
to install only files that have changed.  If you don't have rdist, you should
change the variable rdistInstalled to FALSE.  The installation scripts will
then use CP instead.
.PP
DESTDIR is the root of the installation tree, and is originally defined as 
empty.  DESTDIR is prefixed to each of the other directory names defined.  Some
people like to define DESTDIR as /tmp/ the first time through, just to see that
everything happens correctly.  DESTDIR is the only directory name in which you
include a trailing /.
.PP
LIBDIR is the full pathname of the directory in which the Modula-2 runtime
library libmod.a is installed, and is originally defined as /usr/local/lib.
This directory name is incorporated into the mod executable, but you can
specify a specific library archive file using the
.I -llibname
switch.
.PP
PASSESDIR is the full pathname of the directory in which the various passes of
the compiler are installed, and is originally defined as /usr/local/lib/mod.
This directory name is incorporated into the mod executable, but can be
overridden using the 
.I -B
switch.
.PP
DEFSDIR is the full pathname of the directory in which definition modules
are installed, and is originally defined as /usr/local/defs.
This directory name is incorporated into the
mod executable, but can be supplemented using the 
.I -I
switch.
.PP
MANDIR is the full pathname of the directory in which the man pages for mod and
p2m2 are installed, and is originally defined as /usr/man/manl.
.PP
BINDIR is the full pathname of the directory in which the mod and p2m2
executables are installed, and is originally defined as /usr/local/bin.
.PP
TESTLIBDIR is the full pathname of the directory in which the Modula-2 library
sources reside.  This directory also contains self-relative symbolic
links to the executables in the mod, mod2, xlate, and imc directories.  If you
are going to be making compilers from the sources, you should change TESTLIBDIR
to the appropriate name.  Note that the exectables in the mod directory
depend upon TESTLIBDIR, and so the mod Makefile will be remade anytime the
top-level Metafile.defines is altered.
.PP
MODBINNAME is the name of the executable that invokes the various
phases of the Modula-2 compiler, and is originally defined as mod.
.PP
PCBINNAME is the name of the executable that invokes the various phases
of the Pascal compiler, and is originally defined as wrlpc.
.PP
P2M2BINNAME is the name of the Pascal to Modula-2 converter executable, and is
originally defined as p2m2.
.PP
MODPROFBINNAME is the name of the Modula-2 statement-level profiler, and is
originally defined as modprof.
.PP
PREPBINNAME is the name of the preprocessor used to create the Makefiles from
Metafiles, and uses the same syntax as the preprocessor incorporated into the
Modula-2 compiler.
.PP
Below are descriptions of each directory, and how you can make the individual
components in that directory.  If you just want to install the compiler into
the default directories, you can type
.I "make quickinstall"
in m2-vax and m2-mips, and be done with it.
.PP
Note that the MIPS directory tree does not include the directories xlate, p2m2,
and dbx.
.NH 1
MOD AND WRLPC COMMANDS
.PP
The mod command is a C program that invokes the phases of the Modula-2
compiler.  The wrlpc command is a C program that invokes the phases of the
Pascal compiler (VAX only).  The source is in a directory called mod.  The same
source file is conditionally compiled to create both the Modula-2 and Pascal
versions, as well as testing and installed versions of each.  To create the
installed versions, you should type 
.I "make imod iwrlpc"
and then
.I "make install";
this will install mod as MODBINNAME and wrlpc as PCBINNAME in the BINDIR
directory.
.PP
The testing version of the Modula-2 compiler is called just plain mod and the
testing version of the Pascal compiler is called wrlpc.
.NH 1
FRONT ENDS
.PP
The compiler front end is a YACC, C, and Modula-2 program that parses
individual Modula-2 and Pascal programs and generates P-code for them.  The
same source files (except for the YACC grammar) are conditionally compiled to
create both the Modula-2 and Pascal front ends.  An optimizer may be selected
to improve the speed of the generated code--this optimizer does most for code
that has runtime checks enabled.
.PP
The source for the Modula-2 front end is in the directory mod2.  Typing 
.I "make installmod2.0"
will install the Modula-2 compiler front end as mod2.0 in the PASSESDIR
directory.
.PP
The source for the Pascal front end is in the directory pascal.  All files in
this directory except the Makefile are symbolic links to the mod2 directory.
Typing 
.I "make installpas2.0"
will install the Pascal compiler front end
as mod2.0 in the PASSESDIR directory.
.PP
Note that even the huge definitions for the standard YACC table sizes may be
too small to compile the Modula-2 and Pascal grammars.  I use the following
constants in the YACC source file dextern:
.br
#define NSTATES 1200
.br
#define LSETSIZE 1000
.NH 1
BACK END
.PP
The compiler back end is a Modula-2 program that parses P-code files and
generates VAX/Unix assembly language.
The source for the back end is in the directory
xlate.
Typing 
.I "make install"
will install the compiler back end as mod2.1 in the PASSESDIR directory.
.NH 1
LIBRARY
.PP
The runtime library is a set of C and Modula-2 programs that provide a minimal
runtime environment for Modula-2.  Only a few of the modules actually exist as
Modula-2 implementations.  Most of the others have Modula-2 definition modules
that are merely interfaces to the C implementation.  The SYSTEM.def,
Memory.def, IO.def, and BitOperations.def modules document the pseudo-modules
that are specially parsed by the compiler.  The Storage.def module is provided
for programs that import the standard memory allocation routines ALLOCATE and
DEALLOCATE, although such imports are not needed to use NEW and DISPOSE unless
the \*(lqstandard Modula-2\*(rq switch 
.I -s
is used.
.PP
The unix.def module defines many common Unix system calls in a way that
Modula-2 programs can use, and x.def provides an interface to the X11 library.
The math and longmath modules provide most standard transcendental functions.
The strings module provides several string manipulation functions, and the
parameters module provides an interface to the Unix argc and argv parameters.
Feel free to add your favorites, as long as you send back your additions.
.PP
The file runtime.c contains much of the miscellaneous runtime support.
Included is a procedure called SYSTEM_cputime that returns the accumulated
CPU time for a program in milliseconds.
It may be necessary to modify this on your system.
The file mem.c contains the memory allocation routines, coroutine.c contains
the Modula-2 process routines, and udiv.c contains an unsigned 32-bit
division routine for the VAX.
.PP
Typing 
.I "make install"
will create the library and install it in the LIBDIR directory.  Two versions
of the library are created: one for use in profiling Modula-2 programs (using
the VAX-specific
.I -pg
option) and the other for normal use.
.NH 1
INTERMODULE CHECKER
.PP
The intermodule checker is a Modula-2 program that examines the symbol table
information in a set of Modula-2 object files to be sure they are consistent.
(The intermodule checker does not check any other object files, not even those
generated by the Pascal compiler.)
It will optionally recompile any files that are out of date.
.PP
The intermodule checker uses information similar to that used by dbx.  The
information is placed into the object modules with type 80 decimal (= 50
hexadecimal).  It is possible that this number is in use by another language
processor on the VAX, in which case an alternate should be selected (probably
16 plus some multiple of 32).  To specify a different value, change the
constant STABNMOD2 in mod2/SymbolDumpPC.mod and in imc/stab.def and add the
constant N_MOD2 to /usr/include/stab.h.  For cleanliness, you should also
modify the Unix nm command to recognize Modula-2 entries.  If
/usr/include/stab.h does not define N_MOD2, dbx will assume 80 decimal.
.PP
The source for the intermodule checker is in directory
imc.
Typing 
.I "make install"
will install the intermodule checker as
mod2.2
in the PASSESDIR directory.
.NH 1
P2M2
.PP
p2m2
is a conversion aid for translating Berkeley Pascal programs into Modula-2.
It consists of a YACC parser and some Pascal routines
to read .h and .p files and produce .def and .mod files.
The source is in a directory called p2m2.
.PP
Typing 
.I "make install"
will install p2m2 in the BINDIR directory.
.NH 1
DBX
.PP
We use the debugger
dbx
for Modula-2.
Mark Linton of Stanford University developed the debugger, and has extended
it to work for Modula-2.
Since that software is covered by a 4.x BSD license,
it is not a part of this software distribution.
However, we are distributing a set of updates to the 4.2 version
of DBX; these updates were developed by Mark Linton and are in the public
domain.
.PP
The updates to make DBX are in the directory called
dbx.
To generate a DBX that will work with Modula-2, copy the source files for the
4.2 DBX into the appropriate directory.
You should check that the sizes and version numbers of your source files agree
with the sizes at the beginning of the file mkupdate.
If they do not agree, then you do not have a clean 4.2 version of DBX,
and you will have to integrate the changes by hand (Good luck!).
If they agree, execute the csh command file
.I mkupdate.
.PP
The csh command file mktests will create a set of test directories for dbx.
You should then be able to create a new dbx by typing 
.I "make install".
Dbx includes a set of regression tests which can be run before installing an
updated version.  To run these tests, type
.I "make test".
ManPagecontains a new manual page for dbx.
.NH 1
DOCUMENTATION
.PP
For a description of the standard Modula-2 language, see
N. Wirth,
.I "Programming in Modula-2",
Springer-Verlag, New York, 1982.
.PP
The file
m2.psf
in the
refman
directory contains a complete reference manual for the DECWRL
Modula-2 language, including all extensions.  This document is in PostScript
format.
.PP
This installation guide plus manual pages for the mod, p2m2, and modprof
commands are in a directory called doc.  This directory also includes
some other interesting literature.
.NH 1
BENCHMARKS
.PP
The source for the benchmark program in various languages is supplied
in a directory called bench.
Compile and enjoy.  Feel free to put your favorite compiler to the test.
.PP
Experience has shown that the Modula-2 optimizer does not really do
as well on real programs as it does on benchmarks.  However, it does a
pretty good job of getting rid of redundant runtime checks.
.NH 1
TESTS
.PP
Some test programs are included in a directory called test.
The Makefile has some comments about what they should do.
.NH 1
BUGS
.PP
I'm not in the business of immediately fixing bugs, especially those require
restructuring, but I do want to know about them.  Your chances of getting
a bug fixed are inversely proportional to the size of the test program
demonstrating such bug.  Much better than bug reports, of course, are bug fixes.
.PP
Comments on the compiler and distribution will be appreciated.
.PP
Mail to:
.nf
.in +1i
Joel McCormack
Digital Equipment Corporation
Western Research Laboratory
250 University Avenue
Palo Alto, CA  94301

decwrl!modula-2
modula-2@decwrl.dec.com
decwrl::modula-2
.in -1i
.fi
